/* Écriture des textes en EEPROM pour diminuer la place occupée dans la zone
   des variables dynamiques.
   Plus une chaire est longue, plus son inscription en EEPROM est "rentable". */

#include <EEPROM.h>

int PTR;
char Caractere;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() { Serial.begin(115200); 
  TEXTE_a_inscrire_en_EEPROM.reserve(30); } // 30 caractères sont très suffisants.

void loop() {  
  PTR = 0; // PTR pointe la première adresse disponible pour les textes, la fin étant en 1023.    
  // Ci-dessous : Possibilité de "purger une zone avec des #FF.
  // for (int i=0; i < 1024; i++) EEPROM.write(i, 255); //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  TEXTE_a_inscrire_en_EEPROM = "Img oui ---Pb sur le Lecteur SD."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Code ill"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "gal.Ligne <P = X = Y = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "FIN de proc"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "dure ?D"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "lai par pas : 1smm"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Affichage ?Erreur de lectureValeur hors limites"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PYROGRAVURE EN COURSxxx : OUI : NON"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "U Origine X = U Origine Y = R"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "soudre le probl"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 232); PTR++; // Inscrire un 'è'.
  TEXTE_a_inscrire_en_EEPROM = "mepuis >>> RESET !"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "> Capture ORIGINE <"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Pb Capteur ORGINE !"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Position X ou Y < 0."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Valeur X ou Y > MAX. pour 100."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Syntaxe incorrecte.Fin en ligne "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "ANALYSE du FICHIERMode MANUEL.Mode PAS "; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 224); PTR++; // Inscrire un 'à'.
  TEXTE_a_inscrire_en_EEPROM = " PAS : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Taille lignesTmp Analyse min"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "OPTIONSSYSTEMEChaque B.P. : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "MAXI PW LASER :  pour 100"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Mdf en PYRO. D"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "lai : SecDonn"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "es imagePointer ORG image ?Gravure : "; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 177); PTR++; // Inscrire un "Plus ou moins".
  TEXTE_a_inscrire_en_EEPROM = " xxxxxx"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Test capteurs ORGU sur capteur ORGNON arm"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = " !Position YLigne "; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 224); PTR++; // Inscrire un 'à'.
  TEXTE_a_inscrire_en_EEPROM = " trois BP Ligne "; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 224); PTR++; // Inscrire un 'à'.
  TEXTE_a_inscrire_en_EEPROM = " deux BP BP d"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "duit Chaque B.P. / 10010sU par B.P. CLAVIER"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "& Relire la carte SD."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Focaliser le LASER.Mode LASER continu"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PAUSE en ligne Code Allumer l'"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "cran.xxIncr"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "ment = Suite ?D"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'
  TEXTE_a_inscrire_en_EEPROM = "gagement plateau."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Eteindre l'"; Ecrire_Texte_en_EEPROM();
  EEPROM.write(PTR, 233); PTR++; // Inscrire un 'é'.
  TEXTE_a_inscrire_en_EEPROM = "cran."; Ecrire_Texte_en_EEPROM();
  
  TEXTE_a_inscrire_en_EEPROM = "Version : 07 06 2020"; PTR = 1004; Ecrire_Texte_en_EEPROM();
  Lister_EEPROM();
  INFINI: goto INFINI;}
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE.
  while ((PTR < 1024) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++; }
  Serial.println(); }
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
void Lister_OCTET() {
  byte octet = EEPROM.read(PTR); 
  if ((octet > 31) && (octet < 126)) {Serial.print(' '); Serial.print(char(octet));}
  else Serial.print("..");
  Serial.print(' '); PTR++; }
