/* Programme minimal pour tester l'afficheur OLED et mettre au point les pages écran.

Branchements à effectuer :
--------------------------
 A4 : SDA OLED.
 A5 : SCL OLED.
                                                                    PGM               RAM dynamique
Programme initialisant OLED et présente un texte d'essai.     7350 Octets (23%)      342 Octets (16%) */

//--------------------- Déclarations pour le matériel -----------------------
#include "U8glib.h"
U8GLIB_SH1106_128X64 u8g(U8G_I2C_OPT_NONE); // Usage de la ligne I2C (Two Wire Interface)

//----------------------- Déclaration des variables -------------------------

void setup() {
  u8g.setFont(u8g_font_profont12); // Police de matrices de 6x10 pixels lettres MAJ/min comprises.
  PAGE1();}

void loop() {} // La boucle de base ne fait rien.

void PAGE1() {// Affiche banal. 
  u8g.firstPage(); do {// Début de la boucle d'affichage de la page écran.
  //------------------------------------------------------------------
  u8g.setPrintPos(0, 10); u8g.print("Img01 ---   Img02 OUI");
  u8g.setPrintPos(0, 23); u8g.print("Img03 OUI   Img04 ---");
  u8g.setPrintPos(0, 36); u8g.print("Img05 ---   Img06 ---");
  u8g.setPrintPos(0, 49); u8g.print("Img07 ---   Img08 ---");
  u8g.setPrintPos(0, 62); u8g.print("Img09 OUI   Img10 OUI");}
  //--------------------------------------------------------------
  while(u8g.nextPage());} // Fin de la boucle d'affichage de la page écran.



